//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "fimgcmain.h"
#define ASSERT(a) (a)=(a);
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
#include <fstream>
using namespace std;
TImgForm *ImgForm;
const String fname=ExtractFilePath(Application->ExeName)+"test2.xgr";
//---------------------------------------------------------------------------
__fastcall TImgForm::TImgForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
String GetError(void)
{
LPVOID lpMsgBuf;

FormatMessage(
    FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
    NULL,
    GetLastError(),
    MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
    (LPTSTR) &lpMsgBuf,
    0,
    NULL
);
AnsiString err=(Char*)lpMsgBuf;
return err;
};
void __fastcall TImgForm::ScrollBox1Resize(TObject *Sender)
{
if(Image1->Width<ScrollBox1->ClientRect.Width())
  Image1->Left=(ScrollBox1->ClientRect.Width()-Image1->Width)/2;
else Image1->Left=0;
if(Image1->Height<ScrollBox1->ClientRect.Height())
  Image1->Top=(ScrollBox1->ClientRect.Height()-Image1->Height)/2;
else Image1->Top=0;
}
//---------------------------------------------------------------------------

void __fastcall TImgForm::ScrollBox2Resize(TObject *Sender)
{
if(Image2->Width<ScrollBox1->ClientRect.Width())
  Image2->Left=(ScrollBox1->ClientRect.Width()-Image2->Width)/2;
else Image2->Left=0;
if(Image2->Height<ScrollBox1->ClientRect.Height())
  Image2->Top=(ScrollBox1->ClientRect.Height()-Image2->Height)/2;
else Image2->Top=0;
}
void __fastcall TImgForm::Button1Click(TObject *Sender)
{
BITMAPINFO info;
setmem(&info,sizeof(info),0);
info.bmiHeader.biSize=sizeof(info.bmiHeader);
Graphics::TBitmap* bmp=Image1->Picture->Bitmap;
int res;
void* bitptr=malloc(sizeof(TColor)*bmp->Height*bmp->Width);
res=GetDIBits(bmp->Canvas->Handle,bmp->Handle,0,bmp->Height,0,&info,DIB_RGB_COLORS);
res=GetDIBits(bmp->Canvas->Handle,bmp->Handle,0,bmp->Height,bitptr,&info,DIB_RGB_COLORS);
res=SetDIBits(bmp->Canvas->Handle,bmp->Handle,0,bmp->Height,bitptr,&info,DIB_RGB_COLORS);
ASSERT(res);
Image2->Picture->Bitmap->Height=bmp->Height;
Image2->Picture->Bitmap->Width=bmp->Width;
Image2->Picture->Bitmap->Canvas->Draw(0,0,bmp);
}

void __fastcall TImgForm::ConvertToXGR(TObject *Sender)
{
if(FileExists(fname))DeleteFile(fname);
TFileStream* fs=new TFileStream(fname.c_str(),fmCreate);
BITMAPINFO info;
setmem(&info,sizeof(info),0);
info.bmiHeader.biSize=sizeof(info.bmiHeader);
Graphics::TBitmap* bmp=Image1->Picture->Bitmap;
int res;
GetDIBits(bmp->Canvas->Handle,bmp->Handle,0,bmp->Height,0,&info,DIB_RGB_COLORS);
int pixelsize=info.bmiHeader.biBitCount*bmp->Height*bmp->Width/4;
void* bitptr=malloc(pixelsize);
res=GetDIBits(bmp->Canvas->Handle,bmp->Handle,0,bmp->Height,bitptr,&info,DIB_RGB_COLORS);
int wid=bmp->Width;
int het=bmp->Height;
fs->Write(&wid,sizeof(wid));
fs->Write(&het,sizeof(het));
fs->Write(&info,sizeof(info));
fs->Write(bitptr,pixelsize);
delete fs;
}
//---------------------------------------------------------------------------

void __fastcall TImgForm::LoadBmp(TObject *Sender)
{
if(!Open1->Execute())return;
Image1->Picture->LoadFromFile(Open1->FileName);
}
//---------------------------------------------------------------------------

void __fastcall TImgForm::ConvertToDIB(TObject *Sender)
{
if(!FileExists(fname))
{
Application->MessageBox(String().sprintf("Cannot open file %s!",fname).c_str(),
          "Open error",MB_OK);
return;
};
TFileStream* fs=new TFileStream(fname.c_str(),fmOpenRead);
BITMAPINFO info;
setmem(&info,sizeof(info),0);
Graphics::TBitmap* bmp=Image2->Picture->Bitmap;
int wid,het;
fs->Read(&wid,sizeof(wid));
fs->Read(&het,sizeof(het));
bmp->Width=wid;
bmp->Height=het;
fs->Read(&info,sizeof(info));
int pixelsize=info.bmiHeader.biBitCount*bmp->Height*bmp->Width/4;
void* bitptr=malloc(pixelsize);
fs->Read(bitptr,pixelsize);
SetDIBits(bmp->Canvas->Handle,bmp->Handle,0,bmp->Height,bitptr,&info,DIB_RGB_COLORS);
ScrollBox2Resize(0);
delete fs;
}
//---------------------------------------------------------------------------

void __fastcall TImgForm::ExitClick(TObject *Sender)
{
Close();
}
//---------------------------------------------------------------------------

void __fastcall TImgForm::ProcessClick(TObject *Sender)
{
ConvertToXGR(0);
ConvertToDIB(0);

}
//---------------------------------------------------------------------------

void __fastcall TImgForm::OpenAsXGRClick(TObject *Sender)
{
if(!Open1->Execute())return;
CopyFile(Open1->FileName.c_str(),fname.c_str(),FALSE);
ConvertToDIB(0);
}
//---------------------------------------------------------------------------

void __fastcall TImgForm::SaveAsXGRClick(TObject *Sender)
{
if(!Save1->Execute())return;
ConvertToXGR(0);
RenameFile(fname,Save1->FileName);
}
//---------------------------------------------------------------------------

